#include "qrcode.h"
#include <Adafruit_ST7735.h>
#define TFT_CS        10
#define TFT_RST        9
#define TFT_DC         8

#define SCREEN_OFFSET_X 6
#define SCREEN_OFFSET_Y 6
#define QRCODE_BLOCK 4

Adafruit_ST7735 tft = Adafruit_ST7735(TFT_CS, TFT_DC, TFT_RST);
QRCode qrcode;

void setup(void) 
{
  tft.initR(INITR_GREENTAB);  // Init ST7735S chip, green tab
  tft.setRotation(2);
  tft.fillScreen(ST77XX_BLACK);
  tft.setTextColor(ST77XX_WHITE);
}

void generateQRCode()
{
  uint8_t qrcodeData[qrcode_getBufferSize(3)];
  qrcode_initText(&qrcode, qrcodeData, 3, 0, "HACK THE PLANET");
  tft.fillScreen(ST77XX_WHITE);
    int offsetX = 0;
  int offsetY = 0;
  for (uint8_t y = 0; y < qrcode.size; y++) {
      offsetX = 0;
      for (uint8_t x = 0; x < qrcode.size; x++) {
        if (qrcode_getModule(&qrcode, x, y)){
          tft.drawRect(SCREEN_OFFSET_X + x + offsetX, SCREEN_OFFSET_Y + y + offsetY, QRCODE_BLOCK, QRCODE_BLOCK, ST77XX_BLACK);
          tft.fillRect(SCREEN_OFFSET_X + x + offsetX, SCREEN_OFFSET_Y + y + offsetY, QRCODE_BLOCK, QRCODE_BLOCK, ST77XX_BLACK);
        }
        offsetX+=QRCODE_BLOCK - 1;
      }
      offsetY+=QRCODE_BLOCK - 1;
  }
}

void loop()  
{
  generateQRCode();
  while(1);
}

 
